## emoslib 4.0.7

=== CMakeLists.txt ===
################################################################################
# cmake options:
#   -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#   -DCMAKE_INSTALL_PREFIX=/path/to/install
#
#   -DCMAKE_C_COMPILER=gcc
#   -CMAKE_Fortran_COMPILER=gfortran
#
#   -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#   -DBUILD_SHARED_LIBS=OFF

cmake_minimum_required( VERSION 2.8.4 FATAL_ERROR )

project( libemos )

enable_language( Fortran )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system )

ecbuild_requires_macro_version( 1.6 )

ecbuild_add_option( FEATURE INSTALL_TABLES   DESCRIPTION "enable the installations of BUFR/GRIBex tables and LSM"                       DEFAULT ON )
ecbuild_add_option( FEATURE INSTALL_TOOLS    DESCRIPTION "enable the installations of BUFR/GRIBex tools"                                DEFAULT ON )
ecbuild_add_option( FEATURE FORTRAN90        DESCRIPTION "enable tools which need Fortran 90 (only required for FC=pgf77)"              DEFAULT ON )
ecbuild_add_option( FEATURE SINGLE_PRECISION DESCRIPTION "enable single precision version of library (in addition to double precision)" DEFAULT ON )
ecbuild_add_option( FEATURE GRIBEX_ABORT     DESCRIPTION "abort execution on GRIBEX calls"                                              DEFAULT OFF )


################################################################################
# compiler/linker flags

if( ${CMAKE_SYSTEM_NAME} MATCHES "Linux" )
  set( emos_special_system_def linux FOPEN64 )
elseif( ${CMAKE_SYSTEM_NAME} MATCHES "Darwin" )
  set( emos_special_system_def darwin )
endif()

get_filename_component(Fortran_COMPILER_NAME ${CMAKE_Fortran_COMPILER} NAME)

message(">>> CMAKE_Fortran_COMPILER full path: " ${CMAKE_Fortran_COMPILER})
message(">>> CMAKE_Fortran_COMPILER name:      " ${Fortran_COMPILER_NAME})
message(">>> CMAKE_Fortran_COMPILER ID:        " ${CMAKE_Fortran_COMPILER_ID})

# double precision flags: only for d.p. Fortran-based targets (compiling & linking)
if(CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
  set(emos_double_precision_flags "-fdefault-real-8 -fdefault-double-8")
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "Intel")
  set(emos_double_precision_flags "-r8 -i4")
elseif( CMAKE_Fortran_COMPILER_ID MATCHES "PGI")
  set(emos_double_precision_flags "-r8 -i4")
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "Cray")
  set(emos_double_precision_flags "-s integer32 -s real64")
else()
  set(emos_double_precision_flags "")
endif()

# build type flags
if(CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
  set(CMAKE_Fortran_FLAGS         "-ffixed-line-length-none -fcray-pointer -fno-second-underscore -Wuninitialized -DSHAREDMEMORY")
  set(CMAKE_Fortran_FLAGS_RELEASE "-O2 -mtune=native")
  set(CMAKE_Fortran_FLAGS_RELWITHDEBINFO "-g -O2 -mtune=native")
  set(CMAKE_Fortran_FLAGS_DEBUG   "-g")
  set(emos_special_compiler_def   "gfortran")
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "Intel")
  set(CMAKE_Fortran_FLAGS         "-DSHAREDMEMORY")
  set(CMAKE_Fortran_FLAGS_RELEASE "-f77rtl -O3")
  set(CMAKE_Fortran_FLAGS_RELWITHDEBINFO "-f77rtl -O2 -g")
  set(CMAKE_Fortran_FLAGS_DEBUG   "-f77rtl -O0 -g")
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "PGI")
  set(CMAKE_Fortran_FLAGS         "-fast -Kieee -Mvect=prefetch -noswitcherror")
  set(CMAKE_Fortran_FLAGS_RELEASE "-O2")
  set(CMAKE_Fortran_FLAGS_RELWITHDEBINFO "-g -O2")
  set(CMAKE_Fortran_FLAGS_DEBUG   "-g")
elseif(CMAKE_Fortran_COMPILER_ID MATCHES "Cray")
  set(CMAKE_Fortran_FLAGS         "-ev -Wl,--as-needed -h PIC -emf -hflex_mp=conservative -hfp1 -hadd_paren -DSHAREDMEMORY")
  set(CMAKE_Fortran_FLAGS_RELEASE "")
  set(CMAKE_Fortran_FLAGS_RELWITHDEBINFO "-G2")
  set(CMAKE_Fortran_FLAGS_DEBUG   "-G0 -hfp0")
  set(CMAKE_C_FLAGS               "-Wl,--as-needed -h PIC -DSHAREDMEMORY")
  set(CMAKE_SKIP_RPATH TRUE)
else()
  message("No optimized Fortran compiler flags are known, we just try -O2...")
  set(CMAKE_Fortran_FLAGS_RELEASE "-O2")
  set(CMAKE_Fortran_FLAGS_RELWITHDEBINFO "-O2 -g")
  set(CMAKE_Fortran_FLAGS_DEBUG   "-O0 -g")
endif()


################################################################################
# projects

ecbuild_use_package( PROJECT grib_api VERSION 1.9.16 REQUIRED )

ecbuild_declare_project()

################################################################################
# contents

# project export variables

set( LIBEMOS_INCLUDE_DIRS   ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )
set( LIBEMOS_LIBRARIES      emos )
set( LIBEMOS_TPLS           grib_api )

set_directory_properties(PROPERTIES COMPILE_DEFINITIONS "${ECKIT_DEFINITIONS};${GRIB_API_DEFINITIONS}" )

include_directories( ${LIBEMOS_INCLUDE_DIRS}  )
include_directories( ${GRIB_API_INCLUDE_DIRS} )

if( BUFR_TABLES_PATH )

  message( STATUS "BUFR_TABLES_PATH : ${BUFR_TABLES_PATH}" )

  if( IS_ABSOLUTE ${BUFR_TABLES_PATH} )
    add_definitions( -DBUFR_TABLES_PATH="${BUFR_TABLES_PATH}/" )
  else()
    add_definitions( -DBUFR_TABLES_PATH="${CMAKE_INSTALL_PREFIX}/${BUFR_TABLES_PATH}/" )
  endif()

else()
    add_definitions( -DBUFR_TABLES_PATH="${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}/tables/bufrtables/" )
endif()

# get_directory_property( LIBEMOS_DEFINITIONS COMPILE_DEFINITIONS ) # don't export libemos definitions

# config header

ecbuild_generate_config_headers( DESTINATION ${INSTALL_INCLUDE_DIR}/libemos )

configure_file( libemos_config.h.in  libemos_config.h  @ONLY )
configure_file( libemos_version.h.in libemos_version.h @ONLY )
configure_file( libemos_version.c.in libemos_version.c @ONLY )

install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/libemos_config.h
  ${CMAKE_CURRENT_BINARY_DIR}/libemos_version.h
  DESTINATION
  ${INSTALL_INCLUDE_DIR}/libemos )


################################################################################
# sources

add_subdirectory( common )
add_subdirectory( gribex )
add_subdirectory( interpolation )
add_subdirectory( bufrdc_wmo )
add_subdirectory( pbio )
add_subdirectory( grib_api_merging )
add_subdirectory( tests )
if( ENABLE_INSTALL_TOOLS )
  add_subdirectory( tools )
endif()

#DEFINITIONS  FORTRAN_NO_UNDERSCORE

if( ${Fortran_COMPILER_NAME} MATCHES "ifort" OR CMAKE_Fortran_COMPILER_ID MATCHES "Intel" )
  set_source_files_properties( ${gribex_srcs} PROPERTIES COMPILE_FLAGS "-O0" )
endif()


list( APPEND libemos_srcs
  ${emos_common_src_files}
  ${interpolation_srcs}
  ${gribex_srcs}
  ${bufrdc_wmo_srcs}
  ${pbio_srcs}
  ${grib_api_merging_srcs} )


################################################################################
# tables: BUFR and LSM interpolation

# should we install the old tables?
# probably only for new architectures
if( ENABLE_INSTALL_TABLES )
  install(
    DIRECTORY
      bufrtables
      gribtables
      gribtemplates
      land_sea_mask
    DESTINATION ${INSTALL_DATA_DIR}/tables
    FILE_PERMISSIONS OWNER_READ GROUP_READ WORLD_READ )
endif()

### interpolation tables are always installed
if( NOT INTERPOL_TABLES_PATH )
  set(INTERPOL_TABLES_PATH "${INSTALL_DATA_DIR}/tables" )
endif()

# tables path to passed as PATH into compilation -D must be absolute
if( IS_ABSOLUTE ${INTERPOL_TABLES_PATH} )
  set(emos_interpol_tables_def INTERPOL_TABLES_PATH="${INTERPOL_TABLES_PATH}" )
else()
  set(emos_interpol_tables_def INTERPOL_TABLES_PATH="${CMAKE_INSTALL_PREFIX}/${INTERPOL_TABLES_PATH}" )
endif()

message( STATUS "INTERPOL_TABLES_PATH: ${INTERPOL_TABLES_PATH}" )

# copy the tables/interpol to the build directory
file( COPY tables/interpol DESTINATION ${CMAKE_BINARY_DIR}/${INSTALL_DATA_DIR}/tables )

# always install tables/interpol
install( DIRECTORY tables/interpol DESTINATION ${INTERPOL_TABLES_PATH} FILE_PERMISSIONS OWNER_READ GROUP_READ WORLD_READ )

################################################################################
# final definitions

list( APPEND LIBEMOS_DEFINITIONS
  ${emos_interpol_tables_def}
  ${emos_special_compiler_def}
  ${emos_special_system_def}
  REAL_8
  REAL_BIGGER_THAN_INTEGER
  POINTER_64
  _LARGEFILE64_SOURCE
  _FILE_OFFSET_BITS=64
  LITTLE_ENDIAN
  INTEGER_IS_INT
  ${GRIB_API_DEFINITIONS} )

################################################################################
# targets: libraries (single & douple p.) and version-check executable

set( LIBEMOS_BASE_DIR ${CMAKE_CURRENT_SOURCE_DIR} )

if( HAVE_SINGLE_PRECISION )
  add_subdirectory( libemos-sp )
endif()
add_subdirectory( libemos-dp )

ecbuild_add_executable(
  TARGET      libemos_version
  DEFINITIONS ${LIBEMOS_DEFINITIONS}
  LIBS        emos
  SOURCES     version.c )

ecbuild_add_resources( TARGET libemos_rcs SOURCES_DONT_PACK compile.sh )

################################################################################
# finalize

ecbuild_pkgconfig(
  NAME        emosR64
  URL         "https://software.ecmwf.int/wiki/display/EMOS/"
  DESCRIPTION "Interpolation library, including BUFR & CREX encoding/decoding routines"
  LANGUAGES   C FORTRAN
  LIBRARIES   emosR64 )
if( HAVE_SINGLE_PRECISION )
ecbuild_pkgconfig(
  NAME        emos
  URL         "https://software.ecmwf.int/wiki/display/EMOS/"
  DESCRIPTION "Interpolation library, including BUFR & CREX encoding/decoding routines (single precision)"
  LANGUAGES   C FORTRAN
  LIBRARIES   emos )
endif()

ecbuild_install_project( NAME libemos )
ecbuild_print_summary()

=== bufrtables/CMakeLists.txt ===
############################################################
# CMake options:
#
#   -DCMAKE_INSTALL_PREFIX="/usr/local/apps/libemos/tables/bufr/text/XXXYYY"  (optional: default is /usr/local )

cmake_minimum_required( VERSION 2.8.4 FATAL_ERROR )

project( bufrdc_tables C )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

set( ENABLE_OS_TESTS OFF )
set( ENABLE_OS_FUNCTIONS_TEST OFF )

if( BUFRDC_TABLES_INSTALL_SUFFIX )
	set( INSTALL_DATA_DIR "${BUFRDC_TABLES_INSTALL_SUFFIX}" )
endif()

include( ecbuild_system )

ecbuild_requires_macro_version( 1.6 )

###############################################################################
# project

ecbuild_declare_project()

math( EXPR TABLES_VERSION "100*${BUFRDC_TABLES_MAJOR_VERSION} + 10*${BUFRDC_TABLES_MINOR_VERSION} + ${BUFRDC_TABLES_PATCH_VERSION}") 
set( TABLES_VERSION "000${TABLES_VERSION}" )

file(GLOB links_txt RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.TXT )
file(GLOB distincts RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.distinct )

# debug
# message( STATUS "links_txt" ${links_txt} )
# message( STATUS "distincts" ${distincts} )

install( FILES ${distincts} DESTINATION ${INSTALL_DATA_DIR} )
install( FILES ${links_txt} DESTINATION ${INSTALL_DATA_DIR} )

message( STATUS "${PROJECT_NAME} version: ${TABLES_VERSION}" )
message( STATUS "${PROJECT_NAME} install to: ${CMAKE_INSTALL_PREFIX}/${INSTALL_DATA_DIR}" )

################################################################################
# finalize

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== common/CMakeLists.txt ===
list( APPEND common_src_files
  fortint.h
  fortran.h
)

foreach( src ${common_src_files} )
  list( APPEND emos_common_src_files common/${src} )
endforeach()

set( emos_common_src_files ${emos_common_src_files} PARENT_SCOPE )

=== grib_api_merging/CMakeLists.txt ===
list( APPEND grib_api_merging_src_files
  copy_spec_from_ksec.c
  emos.c
  intuvp2.c
  intvect2.c
  describe_input_field.c
  intf2.c
  intuvs2.c
  emos.h

  fortint.h
)

foreach( src ${grib_api_merging_src_files} )
  list( APPEND grib_api_merging_srcs grib_api_merging/${src} )
endforeach()

set( grib_api_merging_srcs ${grib_api_merging_srcs} PARENT_SCOPE )

=== gribex/CMakeLists.txt ===
if( CMAKE_Fortran_COMPILER_ID MATCHES "Intel" )
  set(CMAKE_Fortran_FLAGS_RELEASE "-O1")           # otherwise breaks second-order packing
endif()

list( APPEND gribex_src_files
  comars.h
  comcomm.h
  comgrb.h
  ecdef1.h
  ecdef2.h
  ecdef3.h
  ecdef4.h
  ecdef5.h
  ecdef6.h
  ecdef7.h
  ecdef8.h
  ecdef9.h
  ecdef10.h
  ecdef11.h
  ecdef12.h
  ecdef13.h
  ecdef14.h
  ecdef15.h
  ecdef16.h
  ecdef17.h
  ecdef18.h
  ecdef19.h
  ecdf190.h
  ecdf191.h
  ECMWFdefinitions.h
  gdecodeStruct.h
  getsetValues.h
  grbcom.h
  gribex.h
  handleLocalDefinitions.h
  sfbits.h
  csgnbt.c
  dsgnbt.c
  ECMWFdefinitions.c
  findLocalDefinitionFile.c
  fortranInterface.c
  gdecode.c
  gdecode1.c
  gdecode2.c
  getsetValues.c
  grpr190.c
  handleLocalDefinitions.c
  jmalloc.c
  jfree.c
  orefdat.c
  sencode.c
  sencode1.c
  sencode2.c
  swap4.c
  valpina.c
  abortx.F
  bufrin.F
  c2bitw.F
  c2cwid.F
  c2dosd.F
  c2gene.F
  c2ordr.F
  c2pack.F
  c2pkvw.F
  c2rnge.F
  c2rows.F
  calcop.F
  cheknum.F
  chktab2.F
  cmpck.F
  codeps.F
  confp.F
  confp2.F
  confp3.F
  confpa.F
  csect4.F
  d2ordr.F
  d2rosd.F
  decext.F
  decfp.F
  decfp2.F
  decogb.F
  decogc.F
  decogd.F
  decogr.F
  decops.F
  decops2.F
  dggsec2.F
  dlasec2.F
  dllsec2.F
  dmesec2.F
  docsec2.F
  dpssec2.F
  dshsec2.F
  dsvsec2.F
  dsect4a.F
  ecdef1.F
  ecdef10.F
  ecdef11.F
  ecdef12.F
  ecdef13.F
  ecdef14.F
  ecdef15.F
  ecdef16.F
  ecdef17.F
  ecdef18.F
  ecdef19.F
  ecdef50.F
  ecdf191.F
  ecdef2.F
  ecdef3.F
  ecdef4.F
  ecdef5.F
  ecdef6.F
  ecdef7.F
  ecdef8.F
  ecdef9.F
  ecloc1.F
  eggsec2.F
  elasec2.F
  ellsec2.F
  emesec2.F
  eocsec2.F
  epssec2.F
  eshsec2.F
  esvsec2.F
  emoscyc.F # not used anywhere and creates unref symbol
  exscal.F
  extmap.F
  ftn1cr.F
  gbitmap.F
  genbin.F
  gendir.F
  getchd.F
  getfb2.F
  getfpd.F
  getib1.F
  getib2.F
  getib3.F
  getind.F
  getlgd.F
  getsys.F
  getusr.F
  grchk1.F
  grchk2.F
  grchk3.F
  grchk4.F
  gribex.F
  gribin.F
  gribnum.F
  grprs0.F
  grprs1.F
  grprs1b.F
  grprs2.F
  grprs3.F
  grprs4.F
  grprs4w.F
  grsdbg.F
  grsdef.F
  grsmax.F
  grsmkp.F
  grsmok.F
  grsn2o.F
  grsref.F
  grsrnd.F
  grsubc.F
  grsvck.F
  grsx2o.F
  gscale.F
  inscal.F
  insmp1.F
  insmp2.F
  inxbit.F
  inxmap.F
  kwchk1.F
  kwloc1.F
  kwprs1.F
  maxmin.F
  maxmn2.F
  maxmni.F
  modval.F
  offset.F
  offset2.F
  packcf.F
  prtbin.F
  prtbk1.F
  prtbk2.F
  prtbl1.F
  prtbl2.F
  ptquasi.F
  qu2reg.F
  qu2reg3.F
  reclen.F
  ref2grb.F
  remsp.F
  repchr.F
  revero.F
  rorint.F
  rowina.F
  rowina2.F
  rowina3.F
  rtb.F
  scm0.F
  setpar.F
  tab2fil.F
  u2l1cr.F
  uncmpck.F
  unpkcf.F
  vod2uv.F
  yyyy2cy.F

  # this is not a complete list of headers, but they seem to be sufficient
  ecdef10.h
  ecdef11.h
  ecdef12.h
  ecdef13.h
  ecdef14.h
  ecdef15.h
  ecdef16.h
  ecdef17.h
  ecdef18.h
  ecdef19.h
  ecdef50.h
  eocsec2.h
  fortint.h
  gdecode.h
  gdecode1.h
  gdecode2.h
  grib_int_t.h
  grprs.h
  sencode.h
  sencode1.h
  sencode2.h
)

foreach( src ${gribex_src_files} )
  list( APPEND gribex_srcs gribex/${src} )
endforeach()

set( gribex_srcs ${gribex_srcs} PARENT_SCOPE )

=== interpolation/CMakeLists.txt ===
list( APPEND interpolation_src_files

  current.h
  debug.h
  grdynam.h
  grfixed.h
  grspace.h
  intf.h
  intlog.h
  jparams.h
  memreq.h
  ouspace.h
  parim.h

  areachk.F
  auresol.F
  chequal.F
  chkout.F
  chkprec.F
  clear_c.F
  csum.F
  ddstyle.F
  dssarea.F
  dummy.F
  dummy2.F
  estima.F
  eulavgg.F
  fft99.F
  fixarea.F
  freecf.F
  funcs.F
  gasetup.F
  gb2gb.F
  getconf.F
  gettru.F
  ggintrp.F
  ggrotat.F
  ggvalue.F
  global.F
  hgengg.F
  hgengrd.F
  hgengrw.F
  hgenll.F
  hgenllw.F
  hgetlsm.F
  hirlam.F
  hirlamw.F
  hirlsm.F
  hll2ll.F
  hll2llw.F
  hll2xyz.F
  hnei12.F
  hneill.F
  hntfap.F
  hntfaph.F
  hntfaps.F
  hntfau.F
  hntfauh.F
  hntfaus.F
  hntfbu.F
  hpshgpw.F
  hrg2gg.F
  hrg2ggw.F
  hrg2ll.F
  hrg2llw.F
  hsp2gg.F
  hsp2gg2.F
  hsp2gg3.F
  hwts12.F
  hwtsll.F
  hwtslsm.F
  iafree.F
  iagcntl.F
  iaidef.F
  iainit.F
  iaintgg.F
  iaintll.F
  iaogdef.F
  iaoldef.F
  iarcntl.F
  iareset.F
  iarmem.F
  ibasini.F
  igalloc.F
  igbess.F
  igdins.F
  igdiwe.F
  igglat.F
  iggmem.F
  iggrid.F
  igint.F
  igintr.F
  iglgrid.F
  iglrev.F
  iglsize.F
  iglsm01.F
  iglsmb.F
  iglsmd.F
  iglsmr.F
  iglsmst.F
  ignorm.F
  igplsm.F
  igpoleg.F
  igpolew.F
  igprec.F
  igscan.F
  igsetup.F
  igsize.F
  igtog.F
  igtogr.F
  igtran.F
  init_cm.F
  insane.F
  intf.F
  intfa.F
  intfap.F
  intfau.F
  intfb.F
  intfbp.F
  intfbu.F
  intfc.F
  intin.F
  intisl.F
  intlog.F
  intlogd.F
  intlogr.F
  intocn.F
  intocnu.F
  intout.F
  intpnum.F
  intuvdh.F
  intuvf.F
  intuvgh.F
  intuvp.F
  intuvph.F
  intuvs.F
  intuvu.F
  intuvxh.F
  intuvy.F
  intvect.F
  intvecy.F
  intwave.F
  intwave2.F
  intwavu.F
  irdiwe.F
  irgmem.F
  irgrid.F
  irgtog.F
  irint.F
  irintr.F
  irlrev.F
  irlsmb.F
  irprec.F
  irscan.F
  irsize.F
  iscrsz.F
  islproc.F
  issame.F
  jacobi.F
  jagggp.F
  jallgp.F
  jallwn.F
  jdebug.F
  jfindfn.F
  jfindfn3.F
  jfindir.F
  jgetgg.F
  jgglat.F
  jintend.F
  jintgg.F
  jintll.F
  jjset99.F
  jmakgg.F
  jmakgg3.F
  jmakll.F
  jmakll3.F
  jmemhan.F
  jmemhan2.F
  jmkofgg.F
  jmovgg.F
  jmovll.F
  jmvugg.F
  jmvull.F
  jnorsgg.F
  jnumgg.F
  jnumggq.F
  jopngg.F
  jopnggf.F
  jopnll.F
  jopnllf.F
  jreadgg.F
  jreadll.F
  jsgggp.F
  jsh2sh.F
  jsllgp.F
  jspleg1.F
  jsppole.F
  jstrll.F
  jstrwll.F
  jsymgg.F
  jsymll.F
  juvpole.F
  jvod2uv.F
  jwindll.F
  jwscal.F
  kintrg.F
  knfrom4.F
  krg2rg.F
  krg2rgd.F
  krg2rgu.F
  krg2rgy.F
  krg2rgz.F
  lgrpr4.F
  ll2xyz.F
  lrekam.F
  lsm_red.F
  lsmfld.F
  makerl.F
  mkbitmp.F
  mkframe.F
  newisl.F
  ngintrp.F
  ngrotat.F
  ngvalue.F
  nmakgg.F
  nmakll.F
  nptwe32.F  # (unsupported entry point)
  numptns.F
  numptwe.F
  oceanp.F
  oceanu.F
  outrep.F
  pddefs.F
  precip.F
  qpassm.F
  reset_c.F
  rpassm.F
  rphi.F
  set99.F
  setrep.F
  sprotat.F
  sscal.F
  strlat.F
  tatorgg.F
  w251idx.F
  waveidx.F
  wavexxx.F
  wv2di32.F  # (unsupported entry point)
  wv2didx.F
  wv2dint.F
  wv2dx32.F  # (unsupported entry point)
  wv2dxxx.F
  wvqlidx.F
  wvqlin2.F  # unused procedure with missing symbol
  wvqlint.F
  xrotate.F
  xyz2ll.F
  yrotate.F
  zprec.F

  dpath_tables_interpol.F90
  wavexx2.F
  wv2dxx2.F

  emosPrecision.c
  fftchk.c
  gmapbit.c
  intlogs.c
  itimer.c
  jchmod.c
  jindex.c
  jopnggsm.c
  jopnllsm.c
  jtimer.c
  makemap.c
  my_ialloc.c
  rddefs.c
  rename_unlink.c
  shareddt.c
  sharedgg.c
  sharedlib.c
  sharedll.c
  showmap.c
  soffset.c
)


foreach( src ${interpolation_src_files} )
  list( APPEND interpolation_srcs interpolation/${src} )
endforeach()

set( interpolation_srcs ${interpolation_srcs} PARENT_SCOPE )

=== libemos-dp/CMakeLists.txt ===
# library sources
foreach( _src ${libemos_srcs} )
  list( APPEND emos_dp_srcs ../${_src} )
endforeach()


# compiler definitions:
# - configure Fortran-based targets for double precision (compilation & linking)
# - allow/disallow GRIBEX with configuration
set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${emos_double_precision_flags}")
if( HAVE_GRIBEX_ABORT )
  set_source_files_properties( ../gribex/gribex.F PROPERTIES COMPILE_DEFINITIONS "GRIBEX_ABORT" )
endif()


# library target
set( CMAKE_Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} )
include_directories( ${LIBEMOS_BASE_DIR}/interpolation ${LIBEMOS_BASE_DIR}/bufrdc_wmo )

ecbuild_add_library(
  TYPE        STATIC
  TARGET      emos
  OUTPUT_NAME "emosR64"
  DEFINITIONS ${LIBEMOS_DEFINITIONS}
  SOURCES     ../libemos_version.c ${emos_dp_srcs}
  GENERATED   ../libemos_version.c )


#if( BUILD_SHARED_LIBS )
#  install(CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" -E create_symlink
#               libemosR64.so ${CMAKE_INSTALL_PREFIX}/${INSTALL_LIB_DIR}/libemos.R64.D64.I32.so)" )
#else()
  install(CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" -E create_symlink
               libemosR64.a ${CMAKE_INSTALL_PREFIX}/${INSTALL_LIB_DIR}/libemos.R64.D64.I32.a)" )
#endif()

=== libemos-sp/CMakeLists.txt ===
# library sources (copy)
foreach( _src ${libemos_srcs} )
  add_custom_command(
    OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/${_src}
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${LIBEMOS_BASE_DIR}/${_src} ${CMAKE_CURRENT_BINARY_DIR}/${_src}
    COMMENT "copying ${_src} from emos (sp)"
    DEPENDS ${LIBEMOS_BASE_DIR}/${_src} )
  list( APPEND emos_sp_srcs ${CMAKE_CURRENT_BINARY_DIR}/${_src} )
endforeach()


# compiler definitions:
# - exclude double-precision specific definitions
# - allow/disallow GRIBEX with configuration
list( REMOVE_ITEM LIBEMOS_DEFINITIONS REAL_8 REAL_BIGGER_THAN_INTEGER )
if( HAVE_GRIBEX_ABORT )
  set_source_files_properties( ../gribex/gribex.F PROPERTIES COMPILE_DEFINITIONS "GRIBEX_ABORT" )
endif()


# library target
set( CMAKE_Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} )
include_directories( ${LIBEMOS_BASE_DIR}/interpolation ${LIBEMOS_BASE_DIR}/bufrdc_wmo )

ecbuild_add_library(
  TYPE        STATIC
  TARGET      emos_sp
  OUTPUT_NAME "emos"
  DEFINITIONS ${LIBEMOS_DEFINITIONS}
  SOURCES     ../libemos_version.c ${emos_sp_srcs}
  GENERATED   ../libemos_version.c )


#if( BUILD_SHARED_LIBS )
#install(CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" -E create_symlink
#             libemos.so ${CMAKE_INSTALL_PREFIX}/${INSTALL_LIB_DIR}/libemos.R32.D64.I32.so)" )
#else()
install(CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" -E create_symlink
             libemos.a ${CMAKE_INSTALL_PREFIX}/${INSTALL_LIB_DIR}/libemos.R32.D64.I32.a)" )
#endif()

=== pbio/CMakeLists.txt ===
list( APPEND pbio_src_files
  bufrgrib.h
  fort2c.h
  blokex.F
  pbbufr.F
  pbcrex.F
  pbgrib.F
  pbionum.F
  emosnum.F
  pbpseu.F
  PBGroutines.c
  extras.c
  fort2c.c
  lwsize.c
  mvchars.c
  pbio.c
  readany.c
  readbufr.c
  readcrex.c
  readgrib.c
  readnext.c
  readprod.c
  recheckLength.c
  gbyte_le.c

  # this is not a complete list of headers, but they seem to be sufficient
  PBGroutines.h
  fileRead.h
  fortint.h
  sizeRoutines.h
)

foreach( src ${pbio_src_files} )
  list( APPEND pbio_srcs pbio/${src} )
endforeach()

set( pbio_srcs ${pbio_srcs} PARENT_SCOPE )

=== tests/CMakeLists.txt ===
find_program( GRIB_COMPARE grib_compare )

if( NOT GRIB_COMPARE AND TARGET grib_compare )
  get_target_property( GRIB_COMPARE grib_compare LOCATION )
endif()

if( NOT GRIB_COMPARE )
  message( WARNING "Could not find grib_compare executable -- turning off some tests!\nTo enable them place 'grib_compare' on the PATH and re-run cmake" )
endif()

# define the grib environment
if( grib_api_BASE_DIR )
  set( _grib_environment
    GRIB_DEFINITION_PATH=${grib_api_BASE_DIR}/share/grib_api/definitions/
    GRIB_SAMPLES_PATH=${grib_api_BASE_DIR}/share/grib_api/samples/ )
endif()

# configure Fortran-based targets for double precision (compilation & linking)
set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${emos_double_precision_flags}")

configure_file( include.sh.in include.sh @ONLY )

##################### INTERPOLATION #######################

ecbuild_add_test(
  TARGET  interpolation_example_grib_api
  SOURCES interpolation_example_grib_api.F
  LIBS    emos ${GRIB_API_LIBRARIES}
  ARGS    -i ${PROJECT_SOURCE_DIR}/data/latlon.grib -o interpolation_example_grib_api.grib
  LINKER_LANGUAGE Fortran
  ENVIRONMENT
    "${_grib_environment}"
    MARS_LSM_PATH=${CMAKE_BINARY_DIR}/${INSTALL_DATA_DIR}/tables/interpol/
    ECMWF_LOCAL_TABLE_PATH=${PROJECT_SOURCE_DIR}/gribtables/
    LOCAL_DEFINITION_TEMPLATES=${PROJECT_SOURCE_DIR}/gribtemplates/ )

ecbuild_add_test(
  TARGET  interpolation_example_wind
  SOURCES interpolation_example_wind.F
  LIBS    emos ${GRIB_API_LIBRARIES}
  ARGS    -i ${PROJECT_SOURCE_DIR}/data/latlon.grib -o interpolation_example_wind.grib
  LINKER_LANGUAGE Fortran
  ENVIRONMENT
    "${_grib_environment}"
    MARS_LSM_PATH=${CMAKE_BINARY_DIR}/${INSTALL_DATA_DIR}/tables/interpol/
    ECMWF_LOCAL_TABLE_PATH=${PROJECT_SOURCE_DIR}/gribtables/
    LOCAL_DEFINITION_TEMPLATES=${PROJECT_SOURCE_DIR}/gribtemplates/ )

ecbuild_add_executable(
  TARGET  interpolation NOINSTALL
  SOURCES interpolation.F
  LIBS    emos ${GRIB_API_LIBRARIES} )

ecbuild_add_test(
  TARGET      interpolation
  TYPE        SCRIPT
  CONDITION   GRIB_COMPARE
  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/interpolation.sh
  RESOURCES   data_ref/spectral-ll.grib data_ref/spectral-rg.grib
  ENVIRONMENT "${_grib_environment}"
)

################### G R I B E X ###########################

if( HAVE_GRIBEX_ABORT )
  ecbuild_add_test(
    TARGET  gribex_abort
    SOURCES gribex_abort.F
    LIBS    emos ${GRIB_API_LIBRARIES}
    LINKER_LANGUAGE Fortran )
  set_tests_properties( gribex_abort PROPERTIES WILL_FAIL TRUE )
else()
  ecbuild_add_test(
    TARGET  interpolation_example_gribex
    SOURCES interpolation_example_gribex.F
    LIBS    emos ${GRIB_API_LIBRARIES}
    ARGS    -i ${PROJECT_SOURCE_DIR}/data/latlon.grib -o interpolation_example_gribex.grib
    LINKER_LANGUAGE Fortran
    ENVIRONMENT
      "${_grib_environment}"
      MARS_LSM_PATH=${CMAKE_BINARY_DIR}/${INSTALL_DATA_DIR}/tables/interpol/
      ECMWF_LOCAL_TABLE_PATH=${PROJECT_SOURCE_DIR}/gribtables/
      LOCAL_DEFINITION_TEMPLATES=${PROJECT_SOURCE_DIR}/gribtemplates/ )
endif()

##################### B U F R #############################

if( ENABLE_FORTRAN90 )
  ecbuild_add_test(
    TARGET  bufr_demo
    SOURCES bufr_demo.f90
    LIBS    emos ${GRIB_API_LIBRARIES}
    LINKER_LANGUAGE Fortran
    ARGS    ${PROJECT_SOURCE_DIR}/data/temp_101.bufr
    ENVIRONMENT BUFR_TABLES=${PROJECT_SOURCE_DIR}/bufrtables )
endif( ENABLE_FORTRAN90 )

ecbuild_add_test(
  TARGET  bufr_decode_all
  COMMAND ${CMAKE_BINARY_DIR}/bin/bufr_decode_all
  LIBS    emos ${GRIB_API_LIBRARIES}
  LINKER_LANGUAGE Fortran
  ARGS    -i ${PROJECT_SOURCE_DIR}/data/temp_101.bufr
  ENVIRONMENT BUFR_TABLES=${PROJECT_SOURCE_DIR}/bufrtables )

#ecbuild_add_test(
#  TARGET  decode_bufr
#  SOURCES bufr/decode_bufr.F
#  LIBS    emos ${GRIB_API_LIBRARIES}
#  ARGS    -i ${PROJECT_SOURCE_DIR}/data/ISMD01_OKPR.bufr
#  LINKER_LANGUAGE Fortran )

#if( ENABLE_INSTALL_TOOLS )
#  ecbuild_add_test(
#    TARGET  tc_tracks
#    TYPE    SCRIPT
#    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/tc_tracks.sh
#    ENVIRONMENT BUFR_TABLES=${PROJECT_SOURCE_DIR}/bufrtables/ )
#endif( ENABLE_INSTALL_TOOLS )

=== tools/CMakeLists.txt ===
add_subdirectory( bufrtools_wmo )

add_subdirectory( singlePointInterpolation )

=== tools/bufrtools_wmo/CMakeLists.txt ===

# configure Fortran-based targets for double precision (compilation & linking)
set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${emos_double_precision_flags}")


# if( CMAKE_Fortran_COMPILER_ID MATCHES "GNU" )
#   set_source_files_properties(
#     bufr_add_bias.F90
#     bufr_merg.F90
#     bufr_merge_tovs.F90
#     PROPERTIES COMPILE_FLAGS "-ffixed-form" )
# elseif( CMAKE_Fortran_COMPILER_ID MATCHES "Intel" )
#   set_source_files_properties(
#     bufr_add_bias.F90
#     bufr_merg.F90
#     bufr_merge_tovs.F90
#     PROPERTIES COMPILE_FLAGS "-fixed" )
# elseif( CMAKE_Fortran_COMPILER_ID MATCHES "Cray")
#   set_source_files_properties(
#     bufr_add_bias.F90
#     bufr_merg.F90
#     bufr_merge_tovs.F90
#     PROPERTIES COMPILE_FLAGS "-f fixed" )
# endif()


################################################################################
# sources

list( APPEND bufrtools_bins_F77
  bufr_0t2
  bufr_88t89
  bufr_check
  bufr_compress
  bufr_decode
  bufr_decode_all
  bufr_filter
  bufr_key
  bufr_nt1
  bufr_ntm
  bufr_obs_filter
  bufr_repack
  bufr_repack_206t205
  bufr_repack_satid
  bufr_ship_anmh
  bufr_ship_anmh_ERA
  bufr_split
  snow_key_repack )

list( APPEND bufrtools_bins_F90
  bufr_add_bias
  bufr_merg
  bufr_merge_tovs
  bufr_simulate
  grib2bufr )

list( APPEND bufrtools_bins_tracks
  tc_tracks
  tc_tracks_10t5
  tc_tracks_det
  tc_tracks_eps )


################################################################################
# F77

ecbuild_add_library(
  TARGET  my_exit NOINSTALL
  TYPE    STATIC
  SOURCES my_exit.F )

foreach( tool ${bufrtools_bins_F77} )
  ecbuild_add_executable(
    TARGET      ${tool}
    SOURCES     ${tool}.F
    DEFINITIONS ${LIBEMOS_DEFINITIONS}
    LIBS        my_exit emos )
endforeach()


################################################################################
# F90

if( ENABLE_FORTRAN90 )

  ecbuild_add_library(
    TARGET  bufr_module NOINSTALL
    TYPE    STATIC
    SOURCES mod_bufr.F90 )

  foreach( tool ${bufrtools_bins_F90} )
    ecbuild_add_executable(
      TARGET      ${tool}
      SOURCES     ${tool}.F90
      DEFINITIONS ${LIBEMOS_DEFINITIONS}
      LIBS        my_exit emos )
  endforeach()

  foreach( tool ${bufrtools_bins_tracks} )
    ecbuild_add_executable(
      TARGET      ${tool}
      SOURCES     ${tool}.F90
      DEFINITIONS ${LIBEMOS_DEFINITIONS}
      LIBS        bufr_module my_exit emos )
  endforeach()

endif( ENABLE_FORTRAN90 )

=== debian/changelog ===
emoslib (2:4.0.7-4) unstable; urgency=medium

  * Build fix for SIGN() real type problem on kFreeBSD in csect4.F 

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 15 Aug 2015 17:09:48 +0100

emoslib (2:4.0.7-3) unstable; urgency=medium

  * Disable tests to allow emos to proceed for gcc5 transition; 
    working on the issue (see #793955) with upstream;
    code in question is obsolete and being removed. 

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 07 Aug 2015 19:23:44 +0100

emoslib (2:4.0.7-2) experimental; urgency=medium

  * Enable tests.

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 26 Jul 2015 13:38:30 +0100

emoslib (2:4.0.7-1) unstable; urgency=medium

  * New upstream release 

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 16 Jul 2015 09:02:02 +0100

emoslib (2:4.0.3+dfsg.1-4) unstable; urgency=medium

  * ppc64el build needs both -fpic and -mcmodel=large. Closes: #790078.
  * Need to add build_fixes.patch to ensure __GNU__ set properly for Hurd.

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 12 Jul 2015 16:58:16 +0100

emoslib (2:4.0.3+dfsg.1-3) unstable; urgency=medium

  * drop_tune.patch: Drop -mtune=native which breaks s390x port. 
  * Don't set -mcmodel=large on arm64, as large+fpic doesn't work.
  * Homepage fixed. Closes: #769179.
  * Build ppc64el, sparc -fPIC not fpic.
  * Build fix for Hurd-i386: Add ifdef __GNU__ case
  * Install cmake module in arch-dependent dir. Closes: #790344.

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 09 Jul 2015 07:44:50 +0100

emoslib (2:4.0.3+dfsg.1-2) unstable; urgency=medium

  * Remove rpath from shlibs. B-D on chrpath. 
  * Fix sed rules that broke some symlinks
  * Add bufrnum back to shlib in new cmake-build system.
  * Change Vcs-Git url to canonical anonscm form. 
  * Use mcmodel=medium on amd64,ppc64; =large on arm64, drop it elsewhere.
    Closes: #790077, #790078.
  * Set DISABLE_OS_CHECK=ON to build on Hurd, KFreeBSD again.
    Closes: #790079.
  * Dedup. libemos-data stuff in interpol, land_sea_mask.

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 27 Jun 2015 12:33:00 +0100

emoslib (2:4.0.3+dfsg.1-1) unstable; urgency=medium

  * New upstream release.
  * Change epoch as version format changes 000392 -> 4.0.3
  * Standards-Version: 3.9.6
  * Switch to cmake-based buildsystem. Lots more dependencies and code. 
  * Add libemos-bin package for new binaries (bufr_*, others)
  * examples/ directory removed.
  * Add Vcs-Git: debian-science to debian/control
  * Build-dependencies: grib-api > 1.9.16, libgrib-api-tools

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 21 Jun 2015 20:55:05 +0100

emoslib (000392+dfsg.1-3) unstable; urgency=medium

  * Acknowledge previously fixed bug (new version): Closes: #622860.
  * Delete link to non-existent config.h file. Closes: #742684.
  * Compress with xz.

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 14 Sep 2014 07:01:40 +0100

emoslib (000392+dfsg.1-2) unstable; urgency=medium

  * Standards-Version: 3.9.5
  * Include grib_api_merging/* into libemos* for MetView.

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 12 Dec 2013 19:32:19 +0000

emoslib (000392+dfsg.1-1) unstable; urgency=low

  * New upstream release.  Now with Apache 2.0 license, not GPL.
  * Standards-Version: 3.9.4; no changes required.
  * debhelper depends >=9 now.
  * Make -dev pkg multiarch: same, -data is m-a: foreign. Closes: #693599.
  * Enable hardening in shared library; build all objects fortified.

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 05 Apr 2013 05:25:57 +0100

emoslib (000382+dfsg-2) unstable; urgency=low

  * Don't hardcode quadmath; it breaks on some archs. Instead let it be
    pulled in by -lgfortran.

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 11 Dec 2011 14:33:21 +0000

emoslib (000382+dfsg-1) unstable; urgency=low

  * New upstream release.
  * Nove from cdbs to debhelper 9
  * Move to Multi-Arch.
  * Standards-Version: 3.9.2
  * Now build-depend on grib-api-1.9.9. 

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 09 Dec 2011 16:18:04 +0000

emoslib (000380+dfsg-3) unstable; urgency=low

  * Fix for FTBFS on powerpc due to hard-coded max value.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 30 Mar 2010 10:21:14 +0100

emoslib (000380+dfsg-2) unstable; urgency=low

  * Move to Standards-Version: 3.8.4; no changes required. 
  * Disable new function WVQLID2 in interpolation/ ; it requires an
    external function that is not present, and causes the sharedlib
    not to link. Closes: #571396. 
  * Add DEP-3 tags to patches. 

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 26 Feb 2010 13:59:04 +0000

emoslib (000380+dfsg-1) unstable; urgency=low

  * New upstream release. 
  * remove_sharedllib_dbg patch now needed. Added file sharedlib.c to
    interpolation/sources.linux

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 21 Jan 2010 13:57:20 +0000

emoslib (000371+dfsg-3) unstable; urgency=low

  * Remove quilt rule, which conflicts with  source format 3. Closes: #561382. 

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 17 Dec 2009 21:31:05 +0000

emoslib (000371+dfsg-2) unstable; urgency=low

  * Fix broken patch that lead to non-shared code. Closes: #559944. 
  * Source format 3.0

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 08 Dec 2009 13:38:29 +0000

emoslib (000371+dfsg-1) unstable; urgency=low

  * New upstream release: EMOS_00371 
  * Move to standards: 3.8.3
  * Patch largefile.patch needed for new sharedlib.c bug in 000371.
  * Add underscore_names patch to add file to sources.linux in interpolation/ 

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 07 Dec 2009 20:26:14 +0000

emoslib (000370.dfsg.2-1) unstable; urgency=low

  * Updated version emos_000370 contains the following fixes:
      Latest Emos library 000370 is updated on 7.9.2009 due to changes of N320 Reduced Gaussian Grid definition.
    
      Beside of N320 there are two more changes:


=== debian/control ===
Source: emoslib
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>=9), gfortran, cmake, 
 libboost-dev (>= 1.47.0), chrpath,
 libgrib-api-dev (>= 1.9.16~), libgrib-api-tools,
 libjasper-dev, libopenjpeg-dev, libpng12-dev, zlib1g-dev
Standards-Version: 3.9.6
Homepage: https://software.ecmwf.int/wiki/display/EMOS/Emoslib
Vcs-Git: git://anonscm.debian.org/debian-science/packages/emos.git

Package: libemos0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libemos-data
Pre-Depends: ${misc:Pre-Depends}
Description: ECMWF Interpolation Library
 The Interpolation library (EMOSLIB) includes Interpolation software and GRIB, 
 BUFR, CREX encoding/decoding routines. It is used by the ECMWF meteorological 
 archival and retrieval system (MARS) and also by the ECMWF graphics 
 package MetView.

Package: libemos-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libemos0d ( = ${binary:Version}), ${misc:Depends}
Recommends: pkg-config
Description: ECMWF Interpolation Library - development
 The Interpolation library (EMOSLIB) includes Interpolation software and GRIB, 
 BUFR, CREX encoding/decoding routines. It is used by the ECMWF meteorological 
 archival and retrieval system (MARS) and also by the ECMWF graphics 
 package MetView.
 .
 This package contains the static libraries and headers needed to build 
 applications against libemos.

Package: libemos-bin
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libemos-data
Description: ECMWF Interpolation Library - binaries
 The Interpolation library (EMOSLIB) includes Interpolation software and GRIB,
 BUFR, CREX encoding/decoding routines. It is used by the ECMWF meteorological
 archival and retrieval system (MARS) and also by the ECMWF graphics
 package MetView.
 .
 This package provide bufr-* and other tools

Package: libemos-data
Architecture: any
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Data files for the ECMWF Interpolation library
 The Interpolation library (EMOSLIB) includes Interpolation software and GRIB, 
 BUFR, CREX encoding/decoding routines. It is used by the ECMWF meteorological 
 archival and retrieval system (MARS) and also by the ECMWF graphics 
 package MetView.
 .
 This package contains the data files needed by EMOSLIB.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# The magic debhelper  rule
%:
	dh $@ --buildsystem=cmake

DESTDIR:=$(shell pwd)/debian/tmp
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
ARCH:=$(shell dpkg --print-architecture)
SHLIB_DIR:= debian/libemos0d/usr/lib/${DEB_HOST_MULTIARCH}
AUTOGENERATED:= libemos-dev.install libemos-dev.links

MCMODEL_FLAGS:=''
BUILD_FLAGS:=''
FPIC:= -fpic
ifeq ($(ARCH), amd64)
  MCMODEL_FLAGS:= -mcmodel=medium
  FPIC:= -fPIC
endif
ifeq ($(ARCH), ppc64el)
  MCMODEL_FLAGS:= -mcmodel=large
  FPIC:= -fPIC
  MCMODEL_FLAGS:= -mcmodel=large
endif
ifeq ($(ARCH), sparc)
  FPIC:= -fPIC
endif
ifeq ($(ARCH), hurd-i386)
  BUILD_FLAGS:= ' -D__GNU__'
endif

override_dh_auto_test:
	# Need links for tests.
	(cd bufrtables && ./links.sh)
	# dh_auto_test
	(cd bufrtables && ./clean.sh)

override_dh_auto_clean:
	find bufrtables -type l -delete
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=Release \
		-DBUILD_SHARED_LIBS=ON \
		-DDISABLE_OS_CHECK=ON \
		-DMCMODEL_FLAGS=${MCMODEL_FLAGS} \
		-DBUILD_FLAGS=${BUILD_FLAGS} \
		-DPIC=${FPIC} \
		-DBUFR_TABLES_PATH=/usr/share/emos/bufrtables
	for f in ${AUTOGENERATED} ; do \
		sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
		done

override_dh_auto_install:
	cd obj-* && cmake -DCMAKE_INSTALL_PREFIX=${DESTDIR} -P cmake_install.cmake
	cd ${DESTDIR}/share/libemos/tables/bufrtables && sh -x ./links.sh
	# Need to rename file, 
	mkdir -p ${SHLIB_DIR}
	cp obj-*/lib/libemos.so		${SHLIB_DIR}/libemos.so.0d
	cp obj-*/lib/libemosR64.so	${SHLIB_DIR}/libemosR64.so.0d
	chrpath -d ${SHLIB_DIR}/libemos*.so.0d 
	dh_auto_install
